## qxw 20110923

=== Makefile ===
## REL+

# Copyright 2011 Mark Owen
# http://www.quinapalus.com
# E-mail: qxw@quinapalus.com
# 
# This file is part of Qxw.
# 
# Qxw is free software: you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License
# as published by the Free Software Foundation.
# 
# Qxw is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Qxw.  If not, see <http://www.gnu.org/licenses/> or
# write to the Free Software Foundation, Inc., 51 Franklin Street,
# Fifth Floor, Boston, MA  02110-1301, USA.


all: qxw

COPTS := -O9 -Wall
LFLAGS := -lgtk-x11-2.0 -lgdk-x11-2.0 -lm -lcairo -lgobject-2.0 -lpcre

qxw: qxw.o filler.o dicts.o gui.o draw.o
	gcc -rdynamic -Wall -ldl qxw.o filler.o dicts.o gui.o draw.o $(LFLAGS) -o qxw
#	gcc -rdynamic -Wall -ldl qxw.o filler.o dicts.o gui.o draw.o `pkg-config --libs gtk+-2.0` -o qxw

qxw.o: qxw.c qxw.h filler.h dicts.h draw.h gui.h common.h
	gcc $(COPTS) -c qxw.c `pkg-config --cflags gtk+-2.0` -o qxw.o

gui.o: gui.c qxw.h filler.h dicts.h draw.h gui.h common.h
	gcc $(COPTS) -c gui.c `pkg-config --cflags gtk+-2.0` -o gui.o

filler.o: filler.c qxw.h filler.h dicts.h common.h
	gcc $(COPTS) -c filler.c -o filler.o

dicts.o: dicts.c dicts.h gui.h common.h
	gcc $(COPTS) -fno-strict-aliasing -c dicts.c -o dicts.o

draw.o: draw.c qxw.h draw.h gui.h common.h
	gcc $(COPTS) -c draw.c `pkg-config --cflags gtk+-2.0` -o draw.o

.PHONY: clean
clean:
	rm -f dicts.o draw.o filler.o gui.o qxw.o qxw

.PHONY: install
install:
	mkdir -p $(DESTDIR)/usr/games
	cp -a qxw $(DESTDIR)/usr/games/qxw
	mkdir -p $(DESTDIR)/usr/include/qxw
	cp -a qxwplugin.h $(DESTDIR)/usr/include/qxw/qxwplugin.h
	mkdir -p $(DESTDIR)/usr/share/applications
	cp -a qxw.desktop $(DESTDIR)/usr/share/applications/qxw.desktop

## REL-

=== debian/changelog ===
qxw (20110923-1ubuntu1) raring; urgency=low

  * Added missing lib to link, fixing FTBFS.

 -- Daniel T Chen <crimsun@ubuntu.com>  Thu, 18 Apr 2013 11:42:21 -0400

qxw (20110923-1) unstable; urgency=low

  * New upstream release

 -- Mark Owen <debian@quinapalus.com>  Fri, 23 Sep 2011 16:13:18 +0100

qxw (20110826-1) unstable; urgency=low

  * New upstream release with minor fixes
  * Minor change to debian/copyright

 -- Mark Owen <debian@quinapalus.com>  Fri, 26 Aug 2011 14:43:10 +0100

qxw (20110818-1) unstable; urgency=low

  * Initial release (Closes: #638465)

 -- Mark Owen <debian@quinapalus.com>  Wed, 18 Aug 2011 14:30:08 +0100

=== debian/control ===
Source: qxw
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mark Owen <debian@quinapalus.com>
Build-Depends: debhelper (>= 7), libcairo2-dev (>= 1.6.0),
 libglib2.0-dev (>= 2.12.0), libgtk2.0-dev (>= 2.8.0),
 libpcre3-dev (>= 7.7)
Standards-Version: 3.9.2
Homepage: http://www.quinapalus.com/qxw.html

Package: qxw
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: wordlist
Description: advanced interactive crossword construction tool
 Qxw is a program to help you create and publish crosswords,
 from the simplest blocked grid to sophisticated thematic
 puzzles. It can make rectangular-, hexagonal- or
 circular-format grids with blocks, bars or both. It
 has an automatic grid-filling facility that can handle a
 wide range of answer treatments and you can even add your
 own answer treatment methods. Grids can be filled using
 letters, digits, or a mixture of both. Qxw can produce
 output in a range of formats ready for publication.
 .
 Qxw is written in C and has a GUI based on GTK+.

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# <Webpage URL> <string match>
http://www.quinapalus.com/qxwdownload.html qxw-(\d*)\.tar\.gz

## qxw 20140331

=== Makefile ===
## REL+

# Copyright 2011-2014 Mark Owen; Windows port by Peter Flippant
# http://www.quinapalus.com
# E-mail: qxw@quinapalus.com
# 
# This file is part of Qxw.
# 
# Qxw is free software: you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License
# as published by the Free Software Foundation.
# 
# Qxw is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Qxw.  If not, see <http://www.gnu.org/licenses/> or
# write to the Free Software Foundation, Inc., 51 Franklin Street,
# Fifth Floor, Boston, MA  02110-1301, USA.


all:: qxw
deb:: qxw

CFLAGS := -Wall -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security `pkg-config --cflags glib-2.0` `pkg-config --cflags gtk+-2.0` -I/opt/local/include
LFLAGS := -Wl,-Bsymbolic-functions -Wl,-z,relro -L/opt/local/lib -lgtk-x11-2.0 -lgdk-x11-2.0 -lm -lcairo -lgobject-2.0 -lpcre -lglib-2.0 -pthread -lgthread-2.0
# -lrt as well?
ifneq ($(filter deb,$(MAKECMDGOALS)),)
  CFLAGS:= $(CFLAGS) -g
else
  CFLAGS:= $(CFLAGS) -O9
endif

qxw: qxw.o filler.o dicts.o gui.o draw.o Makefile
	gcc -rdynamic -Wall -ldl qxw.o filler.o dicts.o gui.o draw.o $(LFLAGS) -o qxw

qxw.o: qxw.c qxw.h filler.h dicts.h draw.h gui.h common.h Makefile
	gcc $(CFLAGS) -c qxw.c -o qxw.o

gui.o: gui.c qxw.h filler.h dicts.h draw.h gui.h common.h Makefile
	gcc $(CFLAGS) -c gui.c -o gui.o

filler.o: filler.c qxw.h filler.h dicts.h common.h Makefile
	gcc $(CFLAGS) -c filler.c -o filler.o

dicts.o: dicts.c dicts.h gui.h common.h Makefile
	gcc $(CFLAGS) -fno-strict-aliasing -c dicts.c -o dicts.o

draw.o: draw.c qxw.h draw.h gui.h common.h Makefile
	gcc $(CFLAGS) -c draw.c -o draw.o

.PHONY: clean
clean:
	rm -f dicts.o draw.o filler.o gui.o qxw.o qxw

.PHONY: install
install:
	mkdir -p $(DESTDIR)/usr/games
	cp -a qxw $(DESTDIR)/usr/games/qxw
	mkdir -p $(DESTDIR)/usr/include/qxw
	cp -a qxwplugin.h $(DESTDIR)/usr/include/qxw/qxwplugin.h
	mkdir -p $(DESTDIR)/usr/share/applications
	cp -a qxw.desktop $(DESTDIR)/usr/share/applications/qxw.desktop
	mkdir -p $(DESTDIR)/usr/share/pixmaps
	cp -a qxw.xpm $(DESTDIR)/usr/share/pixmaps/qxw.xpm
	mkdir -p $(DESTDIR)/usr/share/icons/hicolor/48x48/apps
	cp -a icon-48x48.png $(DESTDIR)/usr/share/icons/hicolor/48x48/apps/qxw.png

## REL-

=== debian/changelog ===
qxw (20140331-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs with GCC. (Closes: #925816)
    - Thanks Reiner Herrmann.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 16 Mar 2020 20:10:51 +0000

qxw (20140331-1) unstable; urgency=low

  * New upstream release
  * Source signature check

 -- Mark Owen <debian@quinapalus.com>  Tue, 01 Apr 2014 15:11:00 +0100

qxw (20140131-1) unstable; urgency=low

  * New upstream release

 -- Mark Owen <debian@quinapalus.com>  Mon, 03 Feb 2014 13:25:52 +0000

qxw (20130906-1) unstable; urgency=low

  * New upstream release

 -- Mark Owen <debian@quinapalus.com>  Thu, 07 Nov 2013 19:42:15 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: qxw
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mark Owen <debian@quinapalus.com>
-Build-Depends: debhelper (>= 7), libcairo2-dev (>= 1.6.0),
+Maintainer: Mark Owen <debian@quinapalus.com>
+Build-Depends: debhelper (>= 7.0.50~), libcairo2-dev (>= 1.6.0),
  libglib2.0-dev (>= 2.12.0), libgtk2.0-dev (>= 2.8.0),
  libpcre3-dev (>= 7.7)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.5
 Homepage: http://www.quinapalus.com/qxw.html
 
 Package: qxw

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# <Webpage URL> <string match>
opts=pgpsigurlmangle=s/$/.asc/ http://www.quinapalus.com/qxwdownload.html qxw-(\d*)\.tar\.gz

## qxw 20200708

=== Makefile ===
## REL+

# Copyright 2011-2020 Mark Owen; Windows port by Peter Flippant
# http://www.quinapalus.com
# E-mail: qxw@quinapalus.com
# 
# This file is part of Qxw.
# 
# Qxw is free software: you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License
# as published by the Free Software Foundation.
# 
# Qxw is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Qxw.  If not, see <http://www.gnu.org/licenses/> or
# write to the Free Software Foundation, Inc., 51 Franklin Street,
# Fifth Floor, Boston, MA  02110-1301, USA.


all:: qxw
deb:: qxw

PKG_CONFIG ?= pkg-config
CFLAGS := -Wall -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -Wno-deprecated-declarations `$(PKG_CONFIG) --cflags glib-2.0` `$(PKG_CONFIG) --cflags gtk+-2.0` -I/opt/local/include `dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS` -Wpedantic -Wextra -Wno-unused-parameter
# CFLAGS := -Wall -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security `$(PKG_CONFIG) --cflags glib-2.0` `$(PKG_CONFIG) --cflags gtk+-2.0` -I/opt/local/include
LFLAGS := -Wl,-Bsymbolic-functions -Wl,-z,relro -L/opt/local/lib `$(PKG_CONFIG) --libs glib-2.0` `$(PKG_CONFIG) --libs gtk+-2.0` -lm -ldl -lpcre -pthread -lgthread-2.0 `dpkg-buildflags --get LDFLAGS`
# -lrt as well?
ifneq ($(filter deb,$(MAKECMDGOALS)),)
  CFLAGS:= $(CFLAGS) -g
else
  CFLAGS:= $(CFLAGS) -g -O3
endif

qxw: qxw.o filler.o treatment.o dicts.o gui.o draw.o alphabets.o deck.o Makefile
	$(CC) -rdynamic -Wall qxw.o filler.o treatment.o dicts.o gui.o draw.o alphabets.o deck.o $(LFLAGS) -o qxw

qxw.o: qxw.c common.h qxw.h filler.h dicts.h treatment.h gui.h draw.h deck.h alphabets.h Makefile
	$(CC) $(CFLAGS) -c qxw.c -o qxw.o

gui.o: gui.c common.h qxw.h filler.h dicts.h treatment.h gui.h draw.h alphabets.h Makefile
	$(CC) $(CFLAGS) -c gui.c -o gui.o

filler.o: filler.c common.h filler.h treatment.h qxw.h gui.h dicts.h Makefile
	$(CC) $(CFLAGS) -c filler.c -o filler.o

treatment.o: treatment.c common.h qxw.h dicts.h treatment.h gui.h Makefile
	$(CC) $(CFLAGS) -fno-strict-aliasing -c treatment.c -o treatment.o

dicts.o: dicts.c common.h qxw.h gui.h dicts.h alphabets.h Makefile
	$(CC) $(CFLAGS) -fno-strict-aliasing -c dicts.c -o dicts.o

draw.o: draw.c common.h qxw.h draw.h gui.h dicts.h Makefile
	$(CC) $(CFLAGS) -c draw.c -o draw.o

deck.o: deck.c common.h qxw.h filler.h alphabets.h dicts.h draw.h treatment.h deck.h Makefile
	$(CC) $(CFLAGS) -c deck.c -o deck.o

alphabets.o: alphabets.c common.h alphabets.h Makefile
	$(CC) $(CFLAGS) -c alphabets.c -o alphabets.o

.PHONY: clean
clean:
	rm -f treatment.o dicts.o draw.o filler.o gui.o qxw.o alphabets.o deck.o qxw

.PHONY: install
install:
	mkdir -p $(DESTDIR)/usr/games
	cp -a qxw $(DESTDIR)/usr/games/qxw
	mkdir -p $(DESTDIR)/usr/include/qxw
	cp -a qxwplugin.h $(DESTDIR)/usr/include/qxw/qxwplugin.h
	mkdir -p $(DESTDIR)/usr/share/applications
	cp -a qxw.desktop $(DESTDIR)/usr/share/applications/qxw.desktop
	mkdir -p $(DESTDIR)/usr/share/pixmaps
	cp -a qxw.xpm $(DESTDIR)/usr/share/pixmaps/qxw.xpm
	mkdir -p $(DESTDIR)/usr/share/icons/hicolor/48x48/apps
	cp -a icon-48x48.png $(DESTDIR)/usr/share/icons/hicolor/48x48/apps/qxw.png
	mkdir -p $(DESTDIR)/usr/share/icons/hicolor/64x64/apps
	cp -a icon-64x64.png $(DESTDIR)/usr/share/icons/hicolor/64x64/apps/qxw.png
	mkdir -p $(DESTDIR)/usr/share/icons/hicolor/96x96/apps
	cp -a icon-96x96.png $(DESTDIR)/usr/share/icons/hicolor/96x96/apps/qxw.png
	mkdir -p $(DESTDIR)/usr/share/icons/hicolor/128x128/apps
	cp -a icon-128x128.png $(DESTDIR)/usr/share/icons/hicolor/128x128/apps/qxw.png
	mkdir -p $(DESTDIR)/usr/share/icons/hicolor/256x256/apps
	cp -a icon-256x256.png $(DESTDIR)/usr/share/icons/hicolor/256x256/apps/qxw.png
#	mkdir -p $(DESTDIR)/usr/share/  /usr/share/lintian/overrides
#	cp -a lintian-binary-overrides $(DESTDIR)/usr/share/lintian/overrides/qxw
#	mkdir -p $(DESTDIR)/usr/share/menu
#	cp -a menufile $(DESTDIR)/usr/share/menu/qxw

## REL-

=== debian/changelog ===
qxw (20200708-3) unstable; urgency=medium

  [ Nick Morrott ]
  * d/control:
    - Declare compliance with Debian Policy 4.7.2
    - Drop redundant Rules-Requires-Root field
  * d/copyright:
    - Refresh years of Debian copyright
    - Replace FSF postal address with gnu.org URL
  * d/patches:
    - Refresh pcre2-port.patch header (UDD noise)
    - Add patch add-appstream-metadata and update handling
      of desktop file during installation
  * d/qxw.lintian-overrides:
    - Drop unused override
  * d/rules:
    - Handle renaming upstream qxw.desktop file during install

  [ Adrian Bunk ]
  * d/rules:
    - Build with -std=gnu17 to workaround FTBFS with GCC 15.
      (Closes: #1097761)

 -- Nick Morrott <nickm@debian.org>  Thu, 30 Oct 2025 20:39:58 +0000

qxw (20200708-2) unstable; urgency=medium

  * Team upload
  * Port to pcre2 (Closes: #999977)

  [ Debian Janitor ]
  * Update standards version to 4.6.1, no changes needed
  * Update lintian override info to new format:
    + debian/source/lintian-overrides: line 3
    + debian/qxw.lintian-overrides: line 2
  * Update standards version to 4.6.2, no changes needed

 -- Bastian Germann <bage@debian.org>  Mon, 04 Sep 2023 08:03:58 +0000

qxw (20200708-1) unstable; urgency=medium

  [ Nick Morrott ]
  * New upstream version 20200708 (Closes: #963784, #901661, #758005)
  * d/changelog:
    - Refresh to include only Debian releases
  * d/control:
    - Set Maintainer to Debian Games Team
    - Refresh Vcs-* fields for Debian Games Team
    - Add myself as an Uploader
    - Bump debhelper-compat level to 13
    - Declare compliance with Debian Policy 4.6.0
    - Drop unnecessary greater-than versioned dependencies
    - Update Homepage to HTTPS URL
  * d/copyright:
    - Add Upstream-Contact details
    - Refresh years of upstream copyright
    - Refresh years of Debian copyright
  * d/docs:
    - Drop empty file
  * d/gbp.conf:
    - Add initial gbp config
    - Set upstream-signatures = True
  * d/patches:
    - Drop gcc9.patch (upstream changes)
  * d/qxw.6:
    - Update homepage to HTTPS URL
  * d/rules:
    - Delete boilerplate cruft
    - Add hardening=+all to build
  * d/s/lintian-overrides:
    - We carry the manpage in debian/
    - Upstream's development repository is private
  * d/u/metadata:
    - Add initial upstream metadata
  * d/watch:
    - Migrate to version 4 watch file format

  [ Mark Owen ]
  * d/control:
    - Set Rules-Requires-Root source field to "no"
    - Refresh short and long package descriptions
  * d/copyright:
    - Migrate copyright file to Copyright Format 1.0
  * d/qxw.6:
    - Refresh manpage documentation
  * d/qxw.lintian-overrides:
    - Add override for false positive in source
  * d/watch:
    - Migrate to HTTPS URL for source

 -- Nick Morrott <nickm@debian.org>  Thu, 28 Apr 2022 01:03:11 +0100

=== debian/control ===
Source: qxw
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Mark Owen <debian@quinapalus.com>,
           Nick Morrott <nickm@debian.org>,
Build-Depends: debhelper-compat (= 13),
               libcairo2-dev,
               libglib2.0-dev,
               libgtk2.0-dev,
               libpcre2-dev,
Standards-Version: 4.7.2
Homepage: https://www.quinapalus.com/qxw.html
Vcs-Browser: https://salsa.debian.org/games-team/qxw
Vcs-Git: https://salsa.debian.org/games-team/qxw.git

Package: qxw
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
Recommends: wordlist
Description: advanced crossword construction tool
 Qxw is a program to help you create and publish crosswords,
 from the simplest blocked grid to sophisticated thematic
 puzzles. It can make rectangular-, hexagonal- or
 circular-format grids with blocks, bars or both. It
 has an automatic grid-filling facility that can handle a
 wide range of answer treatments and you can even add your
 own answer treatment methods. Grids can be filled using
 letters, digits, or a mixture of both; non-Roman and
 custom alphabets are also supported. Qxw can produce
 output in a range of formats ready for publication.
 .
 Qxw also has a non-interactive mode that can solve a wide
 range of word-based constraint satisfaction problems and
 can help automate the exploration of grid designs.
 .
 Qxw is written in C and has a GUI based on GTK+.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -std=gnu17

%:
	dh  $@

# To help ensure `appstreamcli --validate-tree` is successful for an unpacked
# binary package, we need to ensure that both the appdata.xml and .desktop
# files are named using the same RDNS scheme
#
# Tip: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1086181#106
#
execute_after_dh_auto_install:
	mv -v debian/qxw/usr/share/applications/qxw.desktop \
		debian/qxw/usr/share/applications/com.quinapalus.qxw.desktop

override_dh_installchangelogs:
	dh_installchangelogs -k changelog.gz

=== debian/watch ===
version=4

# HTTP site (pgpsigurlmangle)
opts=pgpsigurlmangle=s/$/.asc/ https://www.quinapalus.com/qxwdownload.html \
    @PACKAGE@-(\d{8})@ARCHIVE_EXT@
